benelliprojectileHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active = false},
}

function init()
	RegisterTool("buildingdestruction-m1014", "Annihilator", "MOD/vox/buildingdestruction-m1014.vox", "3")
	SetBool("game.tool.buildingdestruction-m1014.enabled", true)
	SetFloat("game.tool.buildingdestruction-m1014.ammo", 101)

	damage = 0.4
	gravity = Vec(0, 0, 0)
	velocity = 5.5
	reloadTime = 0.55
	shotDelay = 0.25
	ammo = 100
	mags = 300
	pellets = 30
	reloading = false
	unlimitedammo = GetBool("savegame.mod.unlimitedammo")
	strength = 100	--Strength of Shotgun Blast
	maxMass = 10000	--The maximum mass for a body to be affected
	maxDist = 30	--The maximum distance for bodies to be affected

	for i=1, 100 do
		benelliprojectileHandler.shells[i] = deepcopy(benelliprojectileHandler.defaultShell)
	end

	shootTimer = 0
	reloadTimer = 0
	recoilTimer = 0
	lightTimer = 0
	cockTimer = 0
        cooldown = 0

	shootSound = LoadSound("MOD/snd/buildingdestruction-m1014.ogg")
	cocksound = LoadSound("MOD/snd/.ogg")
	dryfiresound = LoadSound("MOD/snd/dryfire.ogg")
	refillsound = LoadSound("MOD/snd/buildingdestruction-m1014_load.ogg")
	loadsound = LoadSound("MOD/snd/buildingdestruction-m1014_load.ogg")
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else
        copy = orig
    end
    return copy
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -50))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end

function Fire()
	if shootTimer > 0 or ammo == 0 then
		return
	end

	local ct = GetCameraTransform()
	aimpos, hit, distance = GetAimPos()

	local fwdpos = TransformToParentPoint(ct, Vec(0, 0, -50))

	for i=1, pellets do
		local p = toolPos
		local aim = fwdpos
		local dir = VecSub(aim, p)
		local spread = InputDown("ctrl") and 1.5 or 3
		dir[1] = dir[1] + (math.random()-0.5)*2*spread
		dir[2] = dir[2] + (math.random()-0.5)*2*spread
		dir[3] = dir[3] + (math.random()-0.5)*2*spread

		benelliprojectileHandler.shells[benelliprojectileHandler.shellNum] = deepcopy(benelliprojectileHandler.defaultShell)
		loadedShell = benelliprojectileHandler.shells[benelliprojectileHandler.shellNum] 
		loadedShell.active = true
		loadedShell.pos = toolPos
		loadedShell.predictedBulletVelocity = VecScale(dir, velocity)
	
		benelliprojectileHandler.shellNum = (benelliprojectileHandler.shellNum%#benelliprojectileHandler.shells) + 1
	end

	---SpawnParticle("fire", toolPos, Vec(0, 1.0+math.random(1,10)*0.1, 0), 0.5, 0.15)
local pp = TransformToParentPoint(ct, Vec(0.28, -0.30, -2.1))
			for i=0,20,1 do
                                ParticleType("plain")
                                ParticleTile(5)
                                local val = math.random()
                                if val < 1/3 then
                                ParticleColor(1, 0.3, 0)
                                elseif val < 1/3*2 then
                                ParticleColor(1, 0.2, 0)
                            else
                                ParticleColor(1, 0.75, 0.25, 0.4)
                            end
                                ParticleRadius(0.1)
                                ParticleEmissive(5, 1)
                                SpawnParticle(pp, Vec(math.random(1,6)-3, math.random(1,6)-3, math.random(1,6)-3), 0.3, 0.01) 
			end
		
	PlaySound(shootSound, GetPlayerTransform().pos, 0.8, false)
	if not unlimitedammo then
		ammo = ammo - 1
	end
	shootTimer = shotDelay
	recoilTimer = shotDelay/4
	lightTimer = shotDelay/4
end

function ProjectileOperations(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(gravity, GetTimeStep())))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local hit, dist = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	
	if hit then
		hitPos = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist))
		projectile.active = false
                MakeHole(hitPos, damage, damage*0.85, damage*0.7)
                if InputDown("rmb") then
                push(hitPos)
		end
	else
		DrawLine(projectile.pos, point2)
                ---PointLight(projectile.pos, 1, 0.75, 0.25, 0.4)
	end
    projectile.pos = point2
end

function Reload()
	if reloading then
		return
	end
	reloading = true
	reloadTimer = reloadTime
end

function tick(dt)
	if GetString("game.player.tool") == "buildingdestruction-m1014" and GetPlayerVehicle() == 0 then
		if InputDown("lmb") and ammo > 0 and not reloading then
			Fire()
		end

    if GetString("game.player.tool") == "buildingdestruction-m1014" and GetBool("game.player.canusetool") then
        ct = GetCameraTransform()
        transform = TransformToParentVec(ct, Vec(0, 0, -1))
	toolPos = Transform()
        if InputDown("lmb") and recoilTimer > 0 then
            local p = TransformToParentPoint(ct, Vec(0, 0, -1.1))
	    local d = VecAdd(TransformToParentVec(ct, Vec(0,0,-1)), rndVec(0.02))
            QueryRejectBody("physical dynamic small")
	    Shoot(p, d, "shotgun", 0.5)
            end

		if InputPressed("lmb") and not reloading then
			if ammo == 0 then
				PlaySound(dryfiresound, GetPlayerTransform().pos, 1, false)
			end
		end

		local b = GetToolBody()
		if b ~= 0 then
			local heightOffset = InputDown("ctrl") and 0.3 or 0.2
			local offset = Transform(Vec(0, heightOffset, 0))
			SetToolTransform(offset)
			toolTrans = GetBodyTransform(b)
			toolPos = TransformToParentPoint(toolTrans, Vec(0.35, -0.55, -2.4))

			if recoilTimer > 0 then
				local t = Transform()
				t.pos = Vec(0, heightOffset, recoilTimer*2)
				t.rot = QuatEuler(recoilTimer*70, 0, 0)
				SetToolTransform(t)
				recoilTimer = recoilTimer - dt
				if recoilTimer < 0.0001 then
					cockTimer = 0.4
				end
			end

			if lightTimer > 0 then
				PointLight(toolPos, 1, 1, 1, 0.5)
				lightTimer = lightTimer - dt
			end

			local shelloffset = Vec(0, 0, 0)
			if cockTimer > 0 then
				cockTimer = cockTimer - dt
				shelloffset = Vec(0.4-cockTimer, 0.6-cockTimer*1.5, 0.4-cockTimer)
			end
			
			if body ~= b then
				body = b
				local shapes = GetBodyShapes(b)
				barrel = shapes[2]
				shell = shapes[3]
				barrelTrans = GetShapeLocalTransform(barrel)
				shellTrans = GetShapeLocalTransform(shell)
			end

			bt = TransformCopy(barrelTrans)
			bt.pos = VecAdd(bt.pos, Vec(0, 0, cockTimer*0.75))
			SetShapeLocalTransform(barrel, bt)

			local cockinv = 0.4 - cockTimer

			st = TransformCopy(shellTrans)
			st.pos = VecAdd(st.pos, shelloffset)
			st.rot = QuatRotateQuat(st.rot, QuatEuler(0, -cockinv*250, -cockinv*500))
			SetShapeLocalTransform(shell, st)
		end

		if not unlimitedammo then
			if ammo < 100 and mags > 1 and InputPressed("R") then
				Reload()
			end

			if GetBool("ammobox.refill") then
				SetBool("ammobox.refill", false)
				mags = mags + 1
				PlaySound(refillsound, GetPlayerTransform().pos, 1, false)
			end

			if reloading then
				if InputDown("lmb") then 
					reloading = false
					Fire()
					return 
				end
				reloadTimer = reloadTimer - GetTimeStep()
				if reloadTimer < 0 then
					ammo = ammo + 10
					mags = mags - 1
					PlaySound(refillsound, GetPlayerTransform().pos, 1, false)
					if ammo < 100 then
						reloadTimer = reloadTime
						return
					end
					reloadTimer = 0
					PlaySound(cocksound)
					reloading = false
				end
			end
		end
		
		if shootTimer > 0 then
			shootTimer = shootTimer - GetTimeStep()
		end
	end

	for key, shell in ipairs(benelliprojectileHandler.shells) do
		if shell.active then
			ProjectileOperations(shell)
		end
	end
end
end

function push() -- Heavy and Super blast push
	local t = GetCameraTransform()
	local pos = t.pos
	local pos2 = TransformToParentPoint(t, Vec(0, 0, 0))
	local dir1 = TransformToParentVec(t, Vec(0, 0, -1))
	local hit, dist, normal, shape = QueryRaycast(pos, dir1, 50)
	blastpoint = VecAdd(pos, VecScale(dir1, dist))

	local mi = VecAdd(blastpoint, Vec(-strength*.03, -strength*.03, -strength*.03))
	local ma = VecAdd(blastpoint, Vec(strength*.03, strength*.03, strength*.03))
	QueryRequire("physical dynamic")
	local bodies = QueryAabbBodies(mi, ma)
							
	for i=1,#bodies do
		local b = bodies[i]
		local bmi, bma = GetBodyBounds(b)
		local bc = VecLerp(bmi, bma, 0.5)
		local dir = VecSub(bc, blastpoint)
		local dist1 = VecLength(dir)
		dir = VecScale(dir, 1.0/dist1)
		local mass = GetBodyMass(b)
		if mass < maxMass then
			local massScale = 1 - math.min(mass/maxMass, 1.0)
			local distScale = 1 - math.min(dist/maxDist, 1.0)
			local add = VecScale(dir1, (strength/2) * (massScale/2) * (distScale*2))
			local vel = VecScale(dir1, .5)
			vel = VecAdd(vel, add)
			SetBodyVelocity(b, vel)
		end
	end
end

function rndVec(length)
	local v = VecNormalize(Vec(math.random(-10,10), math.random(-10,10), math.random(-10,10)))
	return VecScale(v, length)	
end

function draw()
	if GetString("game.player.tool") == "buildingdestruction-m1014" and GetPlayerVehicle() == 0 and not unlimitedammo then
		UiPush()
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			UiFont("bold.ttf", 32)
			UiTextOutline(0,0,0,1,0.1)
			if reloading then
				UiText("Reloading")
			else
				UiText(ammo.."/"..1*math.max(0,(mags-1)))
			end
		UiPop()
	end
	if GetString("game.player.tool") == "buildingdestruction-m1014" and GetPlayerVehicle() == 0 then
		UiPush()
    	UiAlign("center middle")
    	UiTranslate(UiCenter(), UiMiddle());
    	UiImage("circle/crosshair-dot.png")
  	UiPop()

UiPop()
UiPush()
			UiAlign("center")
			UiTextOutline(0, 0, 0, 1, 0.1)
			UiTranslate(220, 1020)
			UiFont("bold.ttf", 26)	
			UiColor(.75, .75, .75)
			UiText("LMB - SHOOT, LMB+RMB - BLOW AWAY")

end		
end